QwtSliderBase(3)

NAME
QwtSliderBase -

SYNOPSIS

Inherits QwtDblRange.

Inherited by QwtDial, QwtKnob, QwtSlider, and QwtWheel.

Detailed Description

A Base class for sliders. QwtSliderBase is a base class for slider widgets. QwtSliderBase handles the mouse events and updates the slider's value accordingly. Derived classes only have to implement the getValue() and getScrollMode() members, and should react to a valueChange(), which normally requires repainting.

Definition at line 30 of file qwt_sldbase.h.

  Public Types
enum ScrollMode { ScrNone, ScrMouse, ScrTimer, ScrDirect, ScrPage }

  Public Slots
virtual void setValue (double val)
virtual void fitValue (double val)
virtual void incValue (int steps)
virtual void setReadOnly (bool)

  Signals
void valueChanged (double value)
void sliderPressed ()
void sliderReleased ()
void sliderMoved (double value)

  Public Member Functions
QwtSliderBase (Qt::Orientation orientation, QWidget *parent=0, const char *name=0, Qt::WFlags flags=0)
virtual ~QwtSliderBase ()
void setUpdateTime (int t)
void stopMoving ()
void setTracking (bool enable)
virtual void setMass (double val)
virtual double mass () const
virtual void setOrientation (Orientation o)
Orientation orientation () const
bool isReadOnly () const
bool isValid () const
void setValid (bool valid)

  Protected Member Functions
void setPosition (const QPoint &p)
virtual void valueChange ()
virtual void timerEvent (QTimerEvent *e)
virtual void mousePressEvent (QMouseEvent *e)
virtual void mouseReleaseEvent (QMouseEvent *e)
virtual void mouseMoveEvent (QMouseEvent *e)
virtual void keyPressEvent (QKeyEvent *e)
virtual void wheelEvent (QWheelEvent *e)
virtual double getValue (const QPoint &p)=0
virtual void getScrollMode (const QPoint &p, int &scrollMode, int &direction)=0

  Protected Attributes
int d_scrollMode
double d_mouseOffset
int d_direction
int d_tracking

Constructor & Destructor Documentation

  QwtSliderBase::QwtSliderBase (Qt::Orientation orientation, QWidget * parent = 0, const char * name = 0, Qt::WFlags flags = 0)

Constructor.

Definition at line 19 of file qwt_sldbase.cpp.

References QwtDblRange::setRange(), and setValue().

  QwtSliderBase::~QwtSliderBase () [virtual]

Destructor.

Definition at line 38 of file qwt_sldbase.cpp.

Member Function Documentation

  void QwtSliderBase::fitValue (double val) [virtual, slot]

Set the slider's value to the nearest integer multiple of the step size.

See also:
    QwtSliderBase::setValue()

Reimplemented from QwtDblRange.

Definition at line 519 of file qwt_sldbase.cpp.

References QwtDblRange::fitValue(), and stopMoving().

  virtual void QwtSliderBase::getScrollMode (const QPoint & p, int & scrollMode, int & direction) [protected, pure virtual]

Determine what to do when the user presses a mouse button.

This function is abstract and has to be implemented by derived classes. It is called on a mousePress event. The derived class can determine what should happen next in dependence of the position where the mouse was pressed by returning scrolling mode and direction. QwtSliderBase knows the following modes:

QwtSliderBase::ScrNone
    Scrolling switched off. Don't change the value.

QwtSliderBase::ScrMouse
    Change the value while the user keeps the button pressed and moves the mouse.

QwtSliderBase::ScrTimer
    Automatic scrolling. Increment the value in the specified direction as long as the user keeps the button pressed.

QwtSliderBase::ScrPage
    Automatic scrolling. Same as ScrTimer, but increment by page size.

Parameters:
    p point where the mouse was pressed

Return values:
    scrollMode The scrolling mode
    direction direction: 1, 0, or -1.

Implemented in QwtDial, QwtSlider, and QwtWheel.

Referenced by mousePressEvent(), and wheelEvent().

  virtual double QwtSliderBase::getValue (const QPoint & p) [protected, pure virtual]

Determine the value corresponding to a specified poind.

This is an abstract virtual function which is called when the user presses or releases a mouse button or moves the mouse. It has to be implemented by the derived class.

Parameters:
    p point

Implemented in QwtDial, QwtSlider, and QwtWheel.

Referenced by mousePressEvent(), and setPosition().

  void QwtSliderBase::incValue (int steps) [virtual, slot]

Increment the value by a specified number of steps.

Parameters:
    steps number of steps

Reimplemented from QwtDblRange.

Definition at line 531 of file qwt_sldbase.cpp.

References QwtDblRange::incValue(), and stopMoving().

  bool QwtSliderBase::isReadOnly () const

In read only mode the slider canīt be controlled by mouse or keyboard.

Returns:
    TRUE if read only

See also:
    setReadOnly

Definition at line 66 of file qwt_sldbase.cpp.

Referenced by QwtDial::drawFocusIndicator(), keyPressEvent(), QwtDial::keyPressEvent(), QwtCompass::keyPressEvent(), mouseMoveEvent(), mousePressEvent(), mouseReleaseEvent(), and wheelEvent().

  bool QwtSliderBase::isValid () const

See also:
    QwtDblRange::isValid

Reimplemented from QwtDblRange.

Definition at line 66 of file qwt_sldbase.h.

References QwtDblRange::isValid().

Referenced by QwtDial::drawContents(), QwtKnob::drawKnob(), QwtAnalogClock::drawNeedle(), QwtCompass::drawScaleContents(), QwtSlider::drawSlider(), keyPressEvent(), QwtDial::keyPressEvent(), mouseMoveEvent(), mousePressEvent(), mouseReleaseEvent(), and wheelEvent().

  void QwtSliderBase::keyPressEvent (QKeyEvent * e) [protected, virtual]

Handles key events

•   Key_Down, KeyLeft
     Decrement by 1

•   Key_Up, Key_Right
     Increment by 1

See also:
    isReadOnly()

Reimplemented in QwtCompass, and QwtDial.

Definition at line 341 of file qwt_sldbase.cpp.

References QwtDblRange::incValue(), isReadOnly(), isValid(), orientation(), QwtDblRange::prevValue(), sliderMoved(), and QwtDblRange::value().

  double QwtSliderBase::mass () const [virtual]

Returns:
    mass

See also:
    QwtSliderBase::setMass

Reimplemented in QwtWheel.

Definition at line 492 of file qwt_sldbase.cpp.

Referenced by QwtWheel::mass().

  void QwtSliderBase::mouseMoveEvent (QMouseEvent * e) [protected, virtual]

Mouse Move Event handler.

Definition at line 274 of file qwt_sldbase.cpp.

References QwtDblRange::exactPrevValue(), QwtDblRange::exactValue(), isReadOnly(), isValid(), QwtDblRange::prevValue(), setPosition(), sliderMoved(), and QwtDblRange::value().

  void QwtSliderBase::mousePressEvent (QMouseEvent * e) [protected, virtual]

Mouse press event handler.

Definition at line 115 of file qwt_sldbase.cpp.

References getScrollMode(), getValue(), isReadOnly(), isValid(), sliderPressed(), stopMoving(), and QwtDblRange::value().

  void QwtSliderBase::mouseReleaseEvent (QMouseEvent * e) [protected, virtual]

Mouse Release Event handler.

Definition at line 166 of file qwt_sldbase.cpp.

References QwtDblRange::fitValue(), QwtDblRange::incPages(), isReadOnly(), isValid(), setPosition(), sliderReleased(), QwtDblRange::step(), stopMoving(), and QwtDblRange::value().

  Qt::Orientation QwtSliderBase::orientation () const

Returns:
    Orientation

See also:
    QwtSliderBase::setOrientation

Definition at line 85 of file qwt_sldbase.cpp.

Referenced by QwtSlider::drawSlider(), QwtSlider::drawThumb(), QwtWheel::drawWheel(), QwtWheel::drawWheelBackground(), QwtSlider::getScrollMode(), QwtWheel::getValue(), QwtSlider::getValue(), keyPressEvent(), QwtSlider::layoutSlider(), QwtWheel::minimumSizeHint(), QwtSlider::minimumSizeHint(), QwtSlider::QwtSlider(), QwtWheel::setOrientation(), QwtWheel::sizePolicy(), QwtSlider::sizePolicy(), and QwtSlider::xyPosition().

  void QwtSliderBase::setMass (double val) [virtual]

Set the slider's mass for flywheel effect.

If the slider's mass is greater then 0, it will continue to move after the mouse button has been released. Its speed decreases with time at a rate depending on the slider's mass. A large mass means that it will continue to move for a long time.

Derived widgets may overload this function to make it public.

Parameters:
    val new mass in kg

See also:
    QwtSliderBase::mass

Reimplemented in QwtWheel.

Definition at line 478 of file qwt_sldbase.cpp.

Referenced by QwtWheel::setMass().

  void QwtSliderBase::setOrientation (Orientation o) [virtual]

Set the orientation.

Parameters:
    o Orientation. Allowed values are Qt::Horizontal and Qt::Vertical.

Definition at line 76 of file qwt_sldbase.cpp.

Referenced by QwtWheel::setOrientation(), and QwtSlider::setOrientation().

  void QwtSliderBase::setPosition (const QPoint & p) [protected]

Move the slider to a specified point, adjust the value and emit signals if necessary. Definition at line 248 of file qwt_sldbase.cpp.

References QwtDblRange::fitValue(), and getValue().

Referenced by mouseMoveEvent(), and mouseReleaseEvent().

  void QwtSliderBase::setReadOnly (bool readOnly) [virtual, slot]

En/Disable read only mode

In read only mode the slider canīt be controlled by mouse or keyboard.

Parameters:
    readOnly Enables in case of TRUE

See also:
    isReadOnly

Definition at line 53 of file qwt_sldbase.cpp.

Referenced by QwtAnalogClock::QwtAnalogClock().

  void QwtSliderBase::setTracking (bool enable)

Enables or disables tracking.

If tracking is enabled, the slider emits a valueChanged() signal whenever its value changes (the default behaviour). If tracking is disabled, the value changed() signal will only be emitted if:.PD 0

•   the user releases the mouse button and the value has changed or

•   at the end of automatic scrolling.

Tracking is enabled by default.

Parameters:
    enable TRUE (enable) or FALSE (disable) tracking.

Definition at line 268 of file qwt_sldbase.cpp.

  void QwtSliderBase::setUpdateTime (int t)

Specify the update interval for automatic scrolling.

Parameters:
    t update interval in milliseconds

See also:
    QwtSliderBase::getScrollMode()

Definition at line 106 of file qwt_sldbase.cpp.

Referenced by QwtKnob::QwtKnob(), and QwtWheel::QwtWheel().

  void QwtSliderBase::setValid (bool valid)

See also:
    QwtDblRange::isValid

Reimplemented from QwtDblRange.

Definition at line 71 of file qwt_sldbase.h.

References QwtDblRange::setValid().

Referenced by QwtAnalogClock::setTime().

  void QwtSliderBase::setValue (double val) [virtual, slot]

Move the slider to a specified value.

This function can be used to move the slider to a value which is not an integer multiple of the step size.

Parameters:
    val new value

See also:
    QwtSliderBase::fitValue

Reimplemented from QwtDblRange.

Definition at line 506 of file qwt_sldbase.cpp.

References QwtDblRange::setValue(), and stopMoving().

Referenced by QwtDial::keyPressEvent(), QwtCompass::keyPressEvent(), QwtSliderBase(), and QwtAnalogClock::setTime().

  void QwtSliderBase::sliderMoved (double value) [signal]

This signal is emitted when the user moves the slider with the mouse.

Parameters:
    value new value

Referenced by keyPressEvent(), QwtDial::keyPressEvent(), mouseMoveEvent(), and wheelEvent().

  void QwtSliderBase::sliderPressed () [signal]

This signal is emitted when the user presses the movable part of the slider (start ScrMouse Mode).

Referenced by mousePressEvent().

  void QwtSliderBase::sliderReleased () [signal]

This signal is emitted when the user releases the movable part of the slider.

Referenced by mouseReleaseEvent().

  void QwtSliderBase::stopMoving ()

Stop updating if automatic scrolling is active.

Definition at line 92 of file qwt_sldbase.cpp.

Referenced by fitValue(), incValue(), mousePressEvent(), mouseReleaseEvent(), setValue(), and timerEvent().

  void QwtSliderBase::timerEvent (QTimerEvent * e) [protected, virtual]

Qt timer event.

Definition at line 388 of file qwt_sldbase.cpp.

References QwtDblRange::exactValue(), QwtDblRange::fitValue(), QwtDblRange::incPages(), QwtDblRange::step(), stopMoving(), and QwtDblRange::value().

  void QwtSliderBase::valueChange () [protected, virtual]

Notify change of value

This function can be reimplemented by derived classes in order to keep track of changes, i.e. repaint the widget. The default implementation emits a valueChanged() signal if tracking is enabled.

Reimplemented from QwtDblRange.

Reimplemented in QwtDial, QwtSlider, and QwtWheel.

Definition at line 455 of file qwt_sldbase.cpp.

References QwtDblRange::value(), and valueChanged().

Referenced by QwtWheel::valueChange(), QwtSlider::valueChange(), and QwtDial::valueChange().

  void QwtSliderBase::valueChanged (double value) [signal]

Notify a change of value.

In the default setting (tracking enabled), this signal will be emitted every time the value changes ( see setTracking() ).

Parameters:
    value new value

Referenced by valueChange().

  void QwtSliderBase::wheelEvent (QWheelEvent * e) [protected, virtual]

Qt wheel event.

Definition at line 304 of file qwt_sldbase.cpp.

References getScrollMode(), QwtDblRange::incPages(), isReadOnly(), isValid(), QwtDblRange::prevValue(), sliderMoved(), and QwtDblRange::value().

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.